"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const hljs = __importStar(require("highlight.js"));
function createHighlightPlugin(config = {}) {
    return function highlightPlugin(tree) {
        const highlightCodeTags = (node) => tree.match.call(node, { tag: 'code' }, highlightNode);
        hljs.configure(config);
        if (config.inline) {
            highlightCodeTags(tree);
        }
        else {
            tree.match({ tag: 'pre' }, highlightCodeTags);
        }
    };
}
exports.default = createHighlightPlugin;
function highlightNode(node) {
    if (!node.attrs)
        node.attrs = {};
    if (!node.attrs.class)
        node.attrs.class = '';
    if (node.attrs.class.indexOf('nohighlight') > -1)
        return node;
    node.attrs.class = (node.attrs.class + ' hljs').trimLeft();
    if (hasExplicitLanguage(node)) {
        const lang = getExplicitLanguage(node);
        node.content = hljs.highlight(lang, node.content[0]).value;
    }
    else {
        node.content = hljs.highlightAuto(node.content[0]).value;
    }
    return node;
}
function hasExplicitLanguage(node) {
    const classes = node.attrs.class;
    return classes.indexOf('language-') > -1 || classes.indexOf('lang-') > -1;
}
function getExplicitLanguage(node) {
    return node.attrs.class.match(/(?:lang|language)-(\w*)/)[1];
}
